diff --git a/src/backend/access/gist/gist.c b/src/backend/access/gist/gist.c
new file mode 100644
index 53bccf6..12224b6
*** a/src/backend/access/gist/gist.c
--- b/src/backend/access/gist/gist.c
***************
*** 16,21 ****
--- 16,22 ----
  
  #include "access/genam.h"
  #include "access/gist_private.h"
+ #include "access/gistscan.h"
  #include "access/xloginsert.h"
  #include "catalog/index.h"
  #include "catalog/pg_collation.h"
***************
*** 24,29 ****
--- 25,31 ----
  #include "storage/indexfsm.h"
  #include "utils/memutils.h"
  #include "utils/rel.h"
+ #include "utils/selfuncs.h"
  
  /* non-export function prototypes */
  static void gistfixsplit(GISTInsertState *state, GISTSTATE *giststate);
*************** static void gistfinishsplit(GISTInsertSt
*** 38,43 ****
--- 40,143 ----
  				GISTSTATE *giststate, List *splitinfo, bool releasebuf);
  static void gistvacuumpage(Relation rel, Page page, Buffer buffer);
  
+ /*
+  * GiST handler function: return IndexAmRoutine with access method parameters
+  * and callbacks.
+  */
+ Datum
+ gisthandler(PG_FUNCTION_ARGS)
+ {
+ 	IndexAmRoutine *amroutine = makeNode(IndexAmRoutine);
+ 
+ 	amroutine->amstrategies = 0;
+ 	amroutine->amsupport = 9;
+ 	amroutine->amcanorder = false;
+ 	amroutine->amcanorderbyop = true;
+ 	amroutine->amcanbackward = false;
+ 	amroutine->amcanunique = false;
+ 	amroutine->amcanmulticol = true;
+ 	amroutine->amoptionalkey = true;
+ 	amroutine->amsearcharray = false;
+ 	amroutine->amsearchnulls = true;
+ 	amroutine->amstorage = true;
+ 	amroutine->amclusterable = true;
+ 	amroutine->ampredlocks = false;
+ 	amroutine->amkeytype = 0;
+ 
+ 	amroutine->aminsert = gistinsert;
+ 	amroutine->ambeginscan = gistbeginscan;
+ 	amroutine->amgettuple = gistgettuple;
+ 	amroutine->amgetbitmap = gistgetbitmap;
+ 	amroutine->amrescan = gistrescan;
+ 	amroutine->amendscan = gistendscan;
+ 	amroutine->ammarkpos = gistmarkpos;
+ 	amroutine->amrestrpos = gistrestrpos;
+ 	amroutine->ambuild = gistbuild;
+ 	amroutine->ambuildempty = gistbuildempty;
+ 	amroutine->ambulkdelete = gistbulkdelete;
+ 	amroutine->amvacuumcleanup = gistvacuumcleanup;
+ 	amroutine->amcanreturn = gistcanreturn;
+ 	amroutine->amcostestimate = gistcostestimate;
+ 	amroutine->amoptions = gistoptions;
+ 	amroutine->amvalidate = gistvalidate;
+ 
+ 	PG_RETURN_POINTER(amroutine);
+ }
+ 
+ void
+ gistvalidate(OpClassInfo *opclass)
+ {
+ 	ListCell   *l;
+ 	bool		procsPresent[GISTNProcs];
+ 	int			i;
+ 
+ 	memset(procsPresent, 0, sizeof(procsPresent));
+ 
+ 	foreach(l, opclass->procedures)
+ 	{
+ 		OpFamilyMember *proc = (OpFamilyMember *) lfirst(l);
+ 
+ 		if (proc->lefttype != opclass->intype ||
+ 			proc->righttype != opclass->intype)
+ 			continue;
+ 
+ 		if (proc->number < 1 || proc->number > GISTNProcs)
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+ 					 errmsg("invalid support number for GiST: %u",
+ 							proc->number)));
+ 
+ 		if (procsPresent[proc->number - 1])
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+ 					 errmsg("GiST support number %u was defined more than once",
+ 							proc->number)));
+ 
+ 		procsPresent[proc->number - 1] = true;
+ 	}
+ 
+ 	for (i = 0; i < GISTNProcs; i++)
+ 	{
+ 		if (i+1 == GIST_DISTANCE_PROC || i+1 == GIST_FETCH_PROC)
+ 			continue; /* optional methods */
+ 		if (!procsPresent[i])
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+ 					 errmsg("GiST support number %u is required", i + 1)));
+ 	}
+ 
+ 	foreach(l, opclass->operators)
+ 	{
+ 		OpFamilyMember *opr = (OpFamilyMember *) lfirst(l);
+ 
+ 		if (OidIsValid(opr->sortfamily)
+ 									&& !procsPresent[GIST_DISTANCE_PROC - 1])
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+ 					 errmsg("GiST distance support function %u is required "
+ 							"for ORDER BY operators", GIST_DISTANCE_PROC)));
+ 	}
+ }
  
  #define ROTATEDIST(d) do { \
  	SplitedPageLayout *tmp=(SplitedPageLayout*)palloc(sizeof(SplitedPageLayout)); \
*************** createTempGistContext(void)
*** 70,79 ****
  /*
   *	gistbuildempty() -- build an empty gist index in the initialization fork
   */
! Datum
! gistbuildempty(PG_FUNCTION_ARGS)
  {
- 	Relation	index = (Relation) PG_GETARG_POINTER(0);
  	Buffer		buffer;
  
  	/* Initialize the root page */
--- 170,178 ----
  /*
   *	gistbuildempty() -- build an empty gist index in the initialization fork
   */
! void
! gistbuildempty(Relation index)
  {
  	Buffer		buffer;
  
  	/* Initialize the root page */
*************** gistbuildempty(PG_FUNCTION_ARGS)
*** 89,96 ****
  
  	/* Unlock and release the buffer */
  	UnlockReleaseBuffer(buffer);
- 
- 	PG_RETURN_VOID();
  }
  
  /*
--- 188,193 ----
*************** gistbuildempty(PG_FUNCTION_ARGS)
*** 99,116 ****
   *	  This is the public interface routine for tuple insertion in GiSTs.
   *	  It doesn't do any work; just locks the relation and passes the buck.
   */
! Datum
! gistinsert(PG_FUNCTION_ARGS)
  {
- 	Relation	r = (Relation) PG_GETARG_POINTER(0);
- 	Datum	   *values = (Datum *) PG_GETARG_POINTER(1);
- 	bool	   *isnull = (bool *) PG_GETARG_POINTER(2);
- 	ItemPointer ht_ctid = (ItemPointer) PG_GETARG_POINTER(3);
- 
- #ifdef NOT_USED
- 	Relation	heapRel = (Relation) PG_GETARG_POINTER(4);
- 	IndexUniqueCheck checkUnique = (IndexUniqueCheck) PG_GETARG_INT32(5);
- #endif
  	IndexTuple	itup;
  	GISTSTATE  *giststate;
  	MemoryContext oldCxt;
--- 196,206 ----
   *	  This is the public interface routine for tuple insertion in GiSTs.
   *	  It doesn't do any work; just locks the relation and passes the buck.
   */
! bool
! gistinsert(Relation r, Datum *values, bool *isnull,
! 		   ItemPointer ht_ctid, Relation heapRel,
! 		   IndexUniqueCheck checkUnique)
  {
  	IndexTuple	itup;
  	GISTSTATE  *giststate;
  	MemoryContext oldCxt;
*************** gistinsert(PG_FUNCTION_ARGS)
*** 136,142 ****
  	MemoryContextSwitchTo(oldCxt);
  	freeGISTstate(giststate);
  
! 	PG_RETURN_BOOL(false);
  }
  
  
--- 226,232 ----
  	MemoryContextSwitchTo(oldCxt);
  	freeGISTstate(giststate);
  
! 	return false;
  }
  
  
diff --git a/src/backend/access/gist/gistbuild.c b/src/backend/access/gist/gistbuild.c
new file mode 100644
index ff888e2..08a029c
*** a/src/backend/access/gist/gistbuild.c
--- b/src/backend/access/gist/gistbuild.c
*************** static BlockNumber gistGetParent(GISTBui
*** 109,120 ****
   * but switches to more efficient buffering build algorithm after a certain
   * number of tuples (unless buffering mode is disabled).
   */
! Datum
! gistbuild(PG_FUNCTION_ARGS)
  {
- 	Relation	heap = (Relation) PG_GETARG_POINTER(0);
- 	Relation	index = (Relation) PG_GETARG_POINTER(1);
- 	IndexInfo  *indexInfo = (IndexInfo *) PG_GETARG_POINTER(2);
  	IndexBuildResult *result;
  	double		reltuples;
  	GISTBuildState buildstate;
--- 109,117 ----
   * but switches to more efficient buffering build algorithm after a certain
   * number of tuples (unless buffering mode is disabled).
   */
! IndexBuildResult *
! gistbuild(Relation heap, Relation index, IndexInfo *indexInfo)
  {
  	IndexBuildResult *result;
  	double		reltuples;
  	GISTBuildState buildstate;
*************** gistbuild(PG_FUNCTION_ARGS)
*** 232,238 ****
  	result->heap_tuples = reltuples;
  	result->index_tuples = (double) buildstate.indtuples;
  
! 	PG_RETURN_POINTER(result);
  }
  
  /*
--- 229,235 ----
  	result->heap_tuples = reltuples;
  	result->index_tuples = (double) buildstate.indtuples;
  
! 	return result;
  }
  
  /*
diff --git a/src/backend/access/gist/gistget.c b/src/backend/access/gist/gistget.c
new file mode 100644
index ce8e582..1adf92f
*** a/src/backend/access/gist/gistget.c
--- b/src/backend/access/gist/gistget.c
*************** getNextNearest(IndexScanDesc scan)
*** 618,628 ****
  /*
   * gistgettuple() -- Get the next tuple in the scan
   */
! Datum
! gistgettuple(PG_FUNCTION_ARGS)
  {
- 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
- 	ScanDirection dir = (ScanDirection) PG_GETARG_INT32(1);
  	GISTScanOpaque so = (GISTScanOpaque) scan->opaque;
  
  	if (dir != ForwardScanDirection)
--- 618,626 ----
  /*
   * gistgettuple() -- Get the next tuple in the scan
   */
! bool
! gistgettuple(IndexScanDesc scan, ScanDirection dir)
  {
  	GISTScanOpaque so = (GISTScanOpaque) scan->opaque;
  
  	if (dir != ForwardScanDirection)
*************** gistgettuple(PG_FUNCTION_ARGS)
*** 651,657 ****
  	if (scan->numberOfOrderBys > 0)
  	{
  		/* Must fetch tuples in strict distance order */
! 		PG_RETURN_BOOL(getNextNearest(scan));
  	}
  	else
  	{
--- 649,655 ----
  	if (scan->numberOfOrderBys > 0)
  	{
  		/* Must fetch tuples in strict distance order */
! 		return getNextNearest(scan);
  	}
  	else
  	{
*************** gistgettuple(PG_FUNCTION_ARGS)
*** 688,694 ****
  
  				so->curPageData++;
  
! 				PG_RETURN_BOOL(true);
  			}
  
  			/*
--- 686,692 ----
  
  				so->curPageData++;
  
! 				return true;
  			}
  
  			/*
*************** gistgettuple(PG_FUNCTION_ARGS)
*** 726,732 ****
  				item = getNextGISTSearchItem(so);
  
  				if (!item)
! 					PG_RETURN_BOOL(false);
  
  				CHECK_FOR_INTERRUPTS();
  
--- 724,730 ----
  				item = getNextGISTSearchItem(so);
  
  				if (!item)
! 					return false;
  
  				CHECK_FOR_INTERRUPTS();
  
*************** gistgettuple(PG_FUNCTION_ARGS)
*** 750,766 ****
  /*
   * gistgetbitmap() -- Get a bitmap of all heap tuple locations
   */
! Datum
! gistgetbitmap(PG_FUNCTION_ARGS)
  {
- 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
- 	TIDBitmap  *tbm = (TIDBitmap *) PG_GETARG_POINTER(1);
  	GISTScanOpaque so = (GISTScanOpaque) scan->opaque;
  	int64		ntids = 0;
  	GISTSearchItem fakeItem;
  
  	if (!so->qual_ok)
! 		PG_RETURN_INT64(0);
  
  	pgstat_count_index_scan(scan->indexRelation);
  
--- 748,762 ----
  /*
   * gistgetbitmap() -- Get a bitmap of all heap tuple locations
   */
! int64
! gistgetbitmap(IndexScanDesc scan, TIDBitmap *tbm)
  {
  	GISTScanOpaque so = (GISTScanOpaque) scan->opaque;
  	int64		ntids = 0;
  	GISTSearchItem fakeItem;
  
  	if (!so->qual_ok)
! 		return 0;
  
  	pgstat_count_index_scan(scan->indexRelation);
  
*************** gistgetbitmap(PG_FUNCTION_ARGS)
*** 791,797 ****
  		pfree(item);
  	}
  
! 	PG_RETURN_INT64(ntids);
  }
  
  /*
--- 787,793 ----
  		pfree(item);
  	}
  
! 	return ntids;
  }
  
  /*
*************** gistgetbitmap(PG_FUNCTION_ARGS)
*** 799,812 ****
   *
   * Opclasses that implement a fetch function support index-only scans.
   */
! Datum
! gistcanreturn(PG_FUNCTION_ARGS)
  {
- 	Relation	index = (Relation) PG_GETARG_POINTER(0);
- 	int			attno = PG_GETARG_INT32(1);
- 
  	if (OidIsValid(index_getprocid(index, attno, GIST_FETCH_PROC)))
! 		PG_RETURN_BOOL(true);
  	else
! 		PG_RETURN_BOOL(false);
  }
--- 795,805 ----
   *
   * Opclasses that implement a fetch function support index-only scans.
   */
! bool
! gistcanreturn(Relation index, int attno)
  {
  	if (OidIsValid(index_getprocid(index, attno, GIST_FETCH_PROC)))
! 		return true;
  	else
! 		return false;
  }
diff --git a/src/backend/access/gist/gistscan.c b/src/backend/access/gist/gistscan.c
new file mode 100644
index a17c5bc..22f0c68
*** a/src/backend/access/gist/gistscan.c
--- b/src/backend/access/gist/gistscan.c
*************** pairingheap_GISTSearchItem_cmp(const pai
*** 54,65 ****
   * Index AM API functions for scanning GiST indexes
   */
  
! Datum
! gistbeginscan(PG_FUNCTION_ARGS)
  {
- 	Relation	r = (Relation) PG_GETARG_POINTER(0);
- 	int			nkeys = PG_GETARG_INT32(1);
- 	int			norderbys = PG_GETARG_INT32(2);
  	IndexScanDesc scan;
  	GISTSTATE  *giststate;
  	GISTScanOpaque so;
--- 54,62 ----
   * Index AM API functions for scanning GiST indexes
   */
  
! IndexScanDesc
! gistbeginscan(Relation r, int nkeys, int norderbys)
  {
  	IndexScanDesc scan;
  	GISTSTATE  *giststate;
  	GISTScanOpaque so;
*************** gistbeginscan(PG_FUNCTION_ARGS)
*** 107,121 ****
  
  	MemoryContextSwitchTo(oldCxt);
  
! 	PG_RETURN_POINTER(scan);
  }
  
! Datum
! gistrescan(PG_FUNCTION_ARGS)
  {
- 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
- 	ScanKey		key = (ScanKey) PG_GETARG_POINTER(1);
- 	ScanKey		orderbys = (ScanKey) PG_GETARG_POINTER(3);
  
  	/* nkeys and norderbys arguments are ignored */
  	GISTScanOpaque so = (GISTScanOpaque) scan->opaque;
--- 104,116 ----
  
  	MemoryContextSwitchTo(oldCxt);
  
! 	return scan;
  }
  
! void
! gistrescan(IndexScanDesc scan, ScanKey key, int nkeys,
! 		   ScanKey orderbys, int norderbys)
  {
  
  	/* nkeys and norderbys arguments are ignored */
  	GISTScanOpaque so = (GISTScanOpaque) scan->opaque;
*************** gistrescan(PG_FUNCTION_ARGS)
*** 314,341 ****
  		if (!first_time)
  			pfree(fn_extras);
  	}
- 
- 	PG_RETURN_VOID();
  }
  
! Datum
! gistmarkpos(PG_FUNCTION_ARGS)
  {
  	elog(ERROR, "GiST does not support mark/restore");
- 	PG_RETURN_VOID();
  }
  
! Datum
! gistrestrpos(PG_FUNCTION_ARGS)
  {
  	elog(ERROR, "GiST does not support mark/restore");
- 	PG_RETURN_VOID();
  }
  
! Datum
! gistendscan(PG_FUNCTION_ARGS)
  {
- 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
  	GISTScanOpaque so = (GISTScanOpaque) scan->opaque;
  
  	/*
--- 309,331 ----
  		if (!first_time)
  			pfree(fn_extras);
  	}
  }
  
! void
! gistmarkpos(IndexScanDesc scan)
  {
  	elog(ERROR, "GiST does not support mark/restore");
  }
  
! void
! gistrestrpos(IndexScanDesc scan)
  {
  	elog(ERROR, "GiST does not support mark/restore");
  }
  
! void
! gistendscan(IndexScanDesc scan)
  {
  	GISTScanOpaque so = (GISTScanOpaque) scan->opaque;
  
  	/*
*************** gistendscan(PG_FUNCTION_ARGS)
*** 343,348 ****
  	 * as well as the queueCxt if there is a separate context for it.
  	 */
  	freeGISTstate(so->giststate);
- 
- 	PG_RETURN_VOID();
  }
--- 333,336 ----
diff --git a/src/backend/access/gist/gistutil.c b/src/backend/access/gist/gistutil.c
new file mode 100644
index 7d596a3..45f6246
*** a/src/backend/access/gist/gistutil.c
--- b/src/backend/access/gist/gistutil.c
*************** gistNewBuffer(Relation r)
*** 808,818 ****
  	return buffer;
  }
  
! Datum
! gistoptions(PG_FUNCTION_ARGS)
  {
- 	Datum		reloptions = PG_GETARG_DATUM(0);
- 	bool		validate = PG_GETARG_BOOL(1);
  	relopt_value *options;
  	GiSTOptions *rdopts;
  	int			numoptions;
--- 808,816 ----
  	return buffer;
  }
  
! bytea *
! gistoptions(Datum reloptions, bool validate)
  {
  	relopt_value *options;
  	GiSTOptions *rdopts;
  	int			numoptions;
*************** gistoptions(PG_FUNCTION_ARGS)
*** 826,832 ****
  
  	/* if none set, we're done */
  	if (numoptions == 0)
! 		PG_RETURN_NULL();
  
  	rdopts = allocateReloptStruct(sizeof(GiSTOptions), options, numoptions);
  
--- 824,830 ----
  
  	/* if none set, we're done */
  	if (numoptions == 0)
! 		return NULL;
  
  	rdopts = allocateReloptStruct(sizeof(GiSTOptions), options, numoptions);
  
*************** gistoptions(PG_FUNCTION_ARGS)
*** 835,841 ****
  
  	pfree(options);
  
! 	PG_RETURN_BYTEA_P(rdopts);
  
  }
  
--- 833,839 ----
  
  	pfree(options);
  
! 	return (bytea *)rdopts;
  
  }
  
diff --git a/src/backend/access/gist/gistvacuum.c b/src/backend/access/gist/gistvacuum.c
new file mode 100644
index a0b0eeb..e0ce620
*** a/src/backend/access/gist/gistvacuum.c
--- b/src/backend/access/gist/gistvacuum.c
***************
*** 25,35 ****
  /*
   * VACUUM cleanup: update FSM
   */
! Datum
! gistvacuumcleanup(PG_FUNCTION_ARGS)
  {
- 	IndexVacuumInfo *info = (IndexVacuumInfo *) PG_GETARG_POINTER(0);
- 	IndexBulkDeleteResult *stats = (IndexBulkDeleteResult *) PG_GETARG_POINTER(1);
  	Relation	rel = info->index;
  	BlockNumber npages,
  				blkno;
--- 25,33 ----
  /*
   * VACUUM cleanup: update FSM
   */
! IndexBulkDeleteResult *
! gistvacuumcleanup(IndexVacuumInfo *info, IndexBulkDeleteResult *stats)
  {
  	Relation	rel = info->index;
  	BlockNumber npages,
  				blkno;
*************** gistvacuumcleanup(PG_FUNCTION_ARGS)
*** 38,44 ****
  
  	/* No-op in ANALYZE ONLY mode */
  	if (info->analyze_only)
! 		PG_RETURN_POINTER(stats);
  
  	/* Set up all-zero stats if gistbulkdelete wasn't called */
  	if (stats == NULL)
--- 36,42 ----
  
  	/* No-op in ANALYZE ONLY mode */
  	if (info->analyze_only)
! 		return stats;
  
  	/* Set up all-zero stats if gistbulkdelete wasn't called */
  	if (stats == NULL)
*************** gistvacuumcleanup(PG_FUNCTION_ARGS)
*** 98,104 ****
  	if (needLock)
  		UnlockRelationForExtension(rel, ExclusiveLock);
  
! 	PG_RETURN_POINTER(stats);
  }
  
  typedef struct GistBDItem
--- 96,102 ----
  	if (needLock)
  		UnlockRelationForExtension(rel, ExclusiveLock);
  
! 	return stats;
  }
  
  typedef struct GistBDItem
*************** pushStackIfSplited(Page page, GistBDItem
*** 137,149 ****
   *
   * Result: a palloc'd struct containing statistical info for VACUUM displays.
   */
! Datum
! gistbulkdelete(PG_FUNCTION_ARGS)
  {
- 	IndexVacuumInfo *info = (IndexVacuumInfo *) PG_GETARG_POINTER(0);
- 	IndexBulkDeleteResult *stats = (IndexBulkDeleteResult *) PG_GETARG_POINTER(1);
- 	IndexBulkDeleteCallback callback = (IndexBulkDeleteCallback) PG_GETARG_POINTER(2);
- 	void	   *callback_state = (void *) PG_GETARG_POINTER(3);
  	Relation	rel = info->index;
  	GistBDItem *stack,
  			   *ptr;
--- 135,144 ----
   *
   * Result: a palloc'd struct containing statistical info for VACUUM displays.
   */
! IndexBulkDeleteResult *
! gistbulkdelete(IndexVacuumInfo *info, IndexBulkDeleteResult *stats,
! 			   IndexBulkDeleteCallback callback, void *callback_state)
  {
  	Relation	rel = info->index;
  	GistBDItem *stack,
  			   *ptr;
*************** gistbulkdelete(PG_FUNCTION_ARGS)
*** 276,280 ****
  		vacuum_delay_point();
  	}
  
! 	PG_RETURN_POINTER(stats);
  }
--- 271,275 ----
  		vacuum_delay_point();
  	}
  
! 	return stats;
  }
diff --git a/src/backend/access/hash/hash.c b/src/backend/access/hash/hash.c
new file mode 100644
index 24b06a5..a51fa7c
*** a/src/backend/access/hash/hash.c
--- b/src/backend/access/hash/hash.c
***************
*** 18,23 ****
--- 18,24 ----
  
  #include "postgres.h"
  
+ #include "access/amapi.h"
  #include "access/hash.h"
  #include "access/relscan.h"
  #include "catalog/index.h"
***************
*** 26,31 ****
--- 27,33 ----
  #include "optimizer/plancat.h"
  #include "storage/bufmgr.h"
  #include "utils/rel.h"
+ #include "utils/selfuncs.h"
  
  
  /* Working state for hashbuild and its callback */
*************** static void hashbuildCallback(Relation i
*** 42,57 ****
  				  bool tupleIsAlive,
  				  void *state);
  
  
  /*
   *	hashbuild() -- build a new hash index.
   */
! Datum
! hashbuild(PG_FUNCTION_ARGS)
  {
- 	Relation	heap = (Relation) PG_GETARG_POINTER(0);
- 	Relation	index = (Relation) PG_GETARG_POINTER(1);
- 	IndexInfo  *indexInfo = (IndexInfo *) PG_GETARG_POINTER(2);
  	IndexBuildResult *result;
  	BlockNumber relpages;
  	double		reltuples;
--- 44,150 ----
  				  bool tupleIsAlive,
  				  void *state);
  
+ /*
+  * Hash handler function: return IndexAmRoutine with access method parameters
+  * and callbacks.
+  */
+ Datum
+ hashhandler(PG_FUNCTION_ARGS)
+ {
+ 	IndexAmRoutine *amroutine = makeNode(IndexAmRoutine);
+ 
+ 	amroutine->amstrategies = 1;
+ 	amroutine->amsupport = 1;
+ 	amroutine->amcanorder = false;
+ 	amroutine->amcanorderbyop = false;
+ 	amroutine->amcanbackward = true;
+ 	amroutine->amcanunique = false;
+ 	amroutine->amcanmulticol = false;
+ 	amroutine->amoptionalkey = false;
+ 	amroutine->amsearcharray = false;
+ 	amroutine->amsearchnulls = false;
+ 	amroutine->amstorage = false;
+ 	amroutine->amclusterable = false;
+ 	amroutine->ampredlocks = false;
+ 	amroutine->amkeytype = INT4OID;
+ 
+ 	amroutine->aminsert = hashinsert;
+ 	amroutine->ambeginscan = hashbeginscan;
+ 	amroutine->amgettuple = hashgettuple;
+ 	amroutine->amgetbitmap = hashgetbitmap;
+ 	amroutine->amrescan = hashrescan;
+ 	amroutine->amendscan = hashendscan;
+ 	amroutine->ammarkpos = hashmarkpos;
+ 	amroutine->amrestrpos = hashrestrpos;
+ 	amroutine->ambuild = hashbuild;
+ 	amroutine->ambuildempty = hashbuildempty;
+ 	amroutine->ambulkdelete = hashbulkdelete;
+ 	amroutine->amvacuumcleanup = hashvacuumcleanup;
+ 	amroutine->amcanreturn = NULL;
+ 	amroutine->amcostestimate = hashcostestimate;
+ 	amroutine->amoptions = hashoptions;
+ 	amroutine->amvalidate = hashvalidate;
+ 
+ 	PG_RETURN_POINTER(amroutine);
+ }
+ 
+ void
+ hashvalidate(OpClassInfo *opclass)
+ {
+ 	ListCell   *l;
+ 
+ 	foreach(l, opclass->procedures)
+ 	{
+ 		OpFamilyMember *proc = (OpFamilyMember *) lfirst(l);
+ 
+ 		if (proc->number != HASHPROC)
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+ 					 errmsg("invalid support number for hash: %u",
+ 							proc->number)));
+ 	}
+ 
+ 	foreach(l, opclass->operators)
+ 	{
+ 		OpFamilyMember *opr = (OpFamilyMember *) lfirst(l);
+ 		bool			leftFound = false, rightFound = false;
+ 		ListCell	   *ll;
+ 
+ 		if (OidIsValid(opr->sortfamily))
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+ 					 errmsg("hash doesn't support ORDER BY operators")));
+ 
+ 		if (opr->number < 1 || opr->number > HTMaxStrategyNumber)
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+ 					 errmsg("invalid strategy number for hash: %u",
+ 							opr->number)));
+ 
+ 		foreach(ll, opclass->procedures)
+ 		{
+ 			OpFamilyMember *proc = (OpFamilyMember *) lfirst(ll);
+ 
+ 			if (proc->lefttype == opr->lefttype)
+ 				leftFound = true;
+ 			if (proc->lefttype == opr->righttype)
+ 				rightFound = true;
+ 		}
+ 
+ 		if (!leftFound || !rightFound)
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_INVALID_OBJECT_DEFINITION),
+ 					 errmsg("no hash procedure found for operator: %u",
+ 							opr->object)));
+ 	}
+ }
  
  /*
   *	hashbuild() -- build a new hash index.
   */
! IndexBuildResult *
! hashbuild(Relation heap, Relation index, IndexInfo *indexInfo)
  {
  	IndexBuildResult *result;
  	BlockNumber relpages;
  	double		reltuples;
*************** hashbuild(PG_FUNCTION_ARGS)
*** 112,131 ****
  	result->heap_tuples = reltuples;
  	result->index_tuples = buildstate.indtuples;
  
! 	PG_RETURN_POINTER(result);
  }
  
  /*
   *	hashbuildempty() -- build an empty hash index in the initialization fork
   */
! Datum
! hashbuildempty(PG_FUNCTION_ARGS)
  {
- 	Relation	index = (Relation) PG_GETARG_POINTER(0);
- 
  	_hash_metapinit(index, 0, INIT_FORKNUM);
- 
- 	PG_RETURN_VOID();
  }
  
  /*
--- 205,220 ----
  	result->heap_tuples = reltuples;
  	result->index_tuples = buildstate.indtuples;
  
! 	return result;
  }
  
  /*
   *	hashbuildempty() -- build an empty hash index in the initialization fork
   */
! void
! hashbuildempty(Relation index)
  {
  	_hash_metapinit(index, 0, INIT_FORKNUM);
  }
  
  /*
*************** hashbuildCallback(Relation index,
*** 167,184 ****
   *	Hash on the heap tuple's key, form an index tuple with hash code.
   *	Find the appropriate location for the new tuple, and put it there.
   */
! Datum
! hashinsert(PG_FUNCTION_ARGS)
  {
- 	Relation	rel = (Relation) PG_GETARG_POINTER(0);
- 	Datum	   *values = (Datum *) PG_GETARG_POINTER(1);
- 	bool	   *isnull = (bool *) PG_GETARG_POINTER(2);
- 	ItemPointer ht_ctid = (ItemPointer) PG_GETARG_POINTER(3);
- 
- #ifdef NOT_USED
- 	Relation	heapRel = (Relation) PG_GETARG_POINTER(4);
- 	IndexUniqueCheck checkUnique = (IndexUniqueCheck) PG_GETARG_INT32(5);
- #endif
  	IndexTuple	itup;
  
  	/*
--- 256,266 ----
   *	Hash on the heap tuple's key, form an index tuple with hash code.
   *	Find the appropriate location for the new tuple, and put it there.
   */
! bool
! hashinsert(Relation rel, Datum *values, bool *isnull,
! 		   ItemPointer ht_ctid, Relation heapRel,
! 		   IndexUniqueCheck checkUnique)
  {
  	IndexTuple	itup;
  
  	/*
*************** hashinsert(PG_FUNCTION_ARGS)
*** 191,197 ****
  	 * chosen in 1986, not of the way nulls are handled here.
  	 */
  	if (isnull[0])
! 		PG_RETURN_BOOL(false);
  
  	/* generate an index tuple */
  	itup = _hash_form_tuple(rel, values, isnull);
--- 273,279 ----
  	 * chosen in 1986, not of the way nulls are handled here.
  	 */
  	if (isnull[0])
! 		return false;
  
  	/* generate an index tuple */
  	itup = _hash_form_tuple(rel, values, isnull);
*************** hashinsert(PG_FUNCTION_ARGS)
*** 201,218 ****
  
  	pfree(itup);
  
! 	PG_RETURN_BOOL(false);
  }
  
  
  /*
   *	hashgettuple() -- Get the next tuple in the scan.
   */
! Datum
! hashgettuple(PG_FUNCTION_ARGS)
  {
- 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
- 	ScanDirection dir = (ScanDirection) PG_GETARG_INT32(1);
  	HashScanOpaque so = (HashScanOpaque) scan->opaque;
  	Relation	rel = scan->indexRelation;
  	Buffer		buf;
--- 283,298 ----
  
  	pfree(itup);
  
! 	return false;
  }
  
  
  /*
   *	hashgettuple() -- Get the next tuple in the scan.
   */
! bool
! hashgettuple(IndexScanDesc scan, ScanDirection dir)
  {
  	HashScanOpaque so = (HashScanOpaque) scan->opaque;
  	Relation	rel = scan->indexRelation;
  	Buffer		buf;
*************** hashgettuple(PG_FUNCTION_ARGS)
*** 314,331 ****
  	/* Return current heap TID on success */
  	scan->xs_ctup.t_self = so->hashso_heappos;
  
! 	PG_RETURN_BOOL(res);
  }
  
  
  /*
   *	hashgetbitmap() -- get all tuples at once
   */
! Datum
! hashgetbitmap(PG_FUNCTION_ARGS)
  {
- 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
- 	TIDBitmap  *tbm = (TIDBitmap *) PG_GETARG_POINTER(1);
  	HashScanOpaque so = (HashScanOpaque) scan->opaque;
  	bool		res;
  	int64		ntids = 0;
--- 394,409 ----
  	/* Return current heap TID on success */
  	scan->xs_ctup.t_self = so->hashso_heappos;
  
! 	return res;
  }
  
  
  /*
   *	hashgetbitmap() -- get all tuples at once
   */
! int64
! hashgetbitmap(IndexScanDesc scan, TIDBitmap *tbm)
  {
  	HashScanOpaque so = (HashScanOpaque) scan->opaque;
  	bool		res;
  	int64		ntids = 0;
*************** hashgetbitmap(PG_FUNCTION_ARGS)
*** 362,380 ****
  		res = _hash_next(scan, ForwardScanDirection);
  	}
  
! 	PG_RETURN_INT64(ntids);
  }
  
  
  /*
   *	hashbeginscan() -- start a scan on a hash index
   */
! Datum
! hashbeginscan(PG_FUNCTION_ARGS)
  {
- 	Relation	rel = (Relation) PG_GETARG_POINTER(0);
- 	int			nkeys = PG_GETARG_INT32(1);
- 	int			norderbys = PG_GETARG_INT32(2);
  	IndexScanDesc scan;
  	HashScanOpaque so;
  
--- 440,455 ----
  		res = _hash_next(scan, ForwardScanDirection);
  	}
  
! 	return ntids;
  }
  
  
  /*
   *	hashbeginscan() -- start a scan on a hash index
   */
! IndexScanDesc
! hashbeginscan(Relation rel, int nkeys, int norderbys)
  {
  	IndexScanDesc scan;
  	HashScanOpaque so;
  
*************** hashbeginscan(PG_FUNCTION_ARGS)
*** 396,414 ****
  	/* register scan in case we change pages it's using */
  	_hash_regscan(scan);
  
! 	PG_RETURN_POINTER(scan);
  }
  
  /*
   *	hashrescan() -- rescan an index relation
   */
! Datum
! hashrescan(PG_FUNCTION_ARGS)
  {
- 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
- 	ScanKey		scankey = (ScanKey) PG_GETARG_POINTER(1);
- 
- 	/* remaining arguments are ignored */
  	HashScanOpaque so = (HashScanOpaque) scan->opaque;
  	Relation	rel = scan->indexRelation;
  
--- 471,486 ----
  	/* register scan in case we change pages it's using */
  	_hash_regscan(scan);
  
! 	return scan;
  }
  
  /*
   *	hashrescan() -- rescan an index relation
   */
! void
! hashrescan(IndexScanDesc scan, ScanKey scankey, int nscankeys,
! 		   ScanKey orderbys, int norderbys)
  {
  	HashScanOpaque so = (HashScanOpaque) scan->opaque;
  	Relation	rel = scan->indexRelation;
  
*************** hashrescan(PG_FUNCTION_ARGS)
*** 434,450 ****
  				scan->numberOfKeys * sizeof(ScanKeyData));
  		so->hashso_bucket_valid = false;
  	}
- 
- 	PG_RETURN_VOID();
  }
  
  /*
   *	hashendscan() -- close down a scan
   */
! Datum
! hashendscan(PG_FUNCTION_ARGS)
  {
- 	IndexScanDesc scan = (IndexScanDesc) PG_GETARG_POINTER(0);
  	HashScanOpaque so = (HashScanOpaque) scan->opaque;
  	Relation	rel = scan->indexRelation;
  
--- 506,519 ----
  				scan->numberOfKeys * sizeof(ScanKeyData));
  		so->hashso_bucket_valid = false;
  	}
  }
  
  /*
   *	hashendscan() -- close down a scan
   */
! void
! hashendscan(IndexScanDesc scan)
  {
  	HashScanOpaque so = (HashScanOpaque) scan->opaque;
  	Relation	rel = scan->indexRelation;
  
*************** hashendscan(PG_FUNCTION_ARGS)
*** 463,490 ****
  
  	pfree(so);
  	scan->opaque = NULL;
- 
- 	PG_RETURN_VOID();
  }
  
  /*
   *	hashmarkpos() -- save current scan position
   */
! Datum
! hashmarkpos(PG_FUNCTION_ARGS)
  {
  	elog(ERROR, "hash does not support mark/restore");
- 	PG_RETURN_VOID();
  }
  
  /*
   *	hashrestrpos() -- restore scan to last saved position
   */
! Datum
! hashrestrpos(PG_FUNCTION_ARGS)
  {
  	elog(ERROR, "hash does not support mark/restore");
- 	PG_RETURN_VOID();
  }
  
  /*
--- 532,555 ----
  
  	pfree(so);
  	scan->opaque = NULL;
  }
  
  /*
   *	hashmarkpos() -- save current scan position
   */
! void
! hashmarkpos(IndexScanDesc scan)
  {
  	elog(ERROR, "hash does not support mark/restore");
  }
  
  /*
   *	hashrestrpos() -- restore scan to last saved position
   */
! void
! hashrestrpos(IndexScanDesc scan)
  {
  	elog(ERROR, "hash does not support mark/restore");
  }
  
  /*
*************** hashrestrpos(PG_FUNCTION_ARGS)
*** 494,506 ****
   *
   * Result: a palloc'd struct containing statistical info for VACUUM displays.
   */
! Datum
! hashbulkdelete(PG_FUNCTION_ARGS)
  {
- 	IndexVacuumInfo *info = (IndexVacuumInfo *) PG_GETARG_POINTER(0);
- 	IndexBulkDeleteResult *stats = (IndexBulkDeleteResult *) PG_GETARG_POINTER(1);
- 	IndexBulkDeleteCallback callback = (IndexBulkDeleteCallback) PG_GETARG_POINTER(2);
- 	void	   *callback_state = (void *) PG_GETARG_POINTER(3);
  	Relation	rel = info->index;
  	double		tuples_removed;
  	double		num_index_tuples;
--- 559,568 ----
   *
   * Result: a palloc'd struct containing statistical info for VACUUM displays.
   */
! IndexBulkDeleteResult *
! hashbulkdelete(IndexVacuumInfo *info, IndexBulkDeleteResult *stats,
! 			   IndexBulkDeleteCallback callback, void *callback_state)
  {
  	Relation	rel = info->index;
  	double		tuples_removed;
  	double		num_index_tuples;
*************** loop_top:
*** 670,676 ****
  	stats->tuples_removed += tuples_removed;
  	/* hashvacuumcleanup will fill in num_pages */
  
! 	PG_RETURN_POINTER(stats);
  }
  
  /*
--- 732,738 ----
  	stats->tuples_removed += tuples_removed;
  	/* hashvacuumcleanup will fill in num_pages */
  
! 	return stats;
  }
  
  /*
*************** loop_top:
*** 678,701 ****
   *
   * Result: a palloc'd struct containing statistical info for VACUUM displays.
   */
! Datum
! hashvacuumcleanup(PG_FUNCTION_ARGS)
  {
- 	IndexVacuumInfo *info = (IndexVacuumInfo *) PG_GETARG_POINTER(0);
- 	IndexBulkDeleteResult *stats = (IndexBulkDeleteResult *) PG_GETARG_POINTER(1);
  	Relation	rel = info->index;
  	BlockNumber num_pages;
  
  	/* If hashbulkdelete wasn't called, return NULL signifying no change */
  	/* Note: this covers the analyze_only case too */
  	if (stats == NULL)
! 		PG_RETURN_POINTER(NULL);
  
  	/* update statistics */
  	num_pages = RelationGetNumberOfBlocks(rel);
  	stats->num_pages = num_pages;
  
! 	PG_RETURN_POINTER(stats);
  }
  
  
--- 740,761 ----
   *
   * Result: a palloc'd struct containing statistical info for VACUUM displays.
   */
! IndexBulkDeleteResult *
! hashvacuumcleanup(IndexVacuumInfo *info, IndexBulkDeleteResult *stats)
  {
  	Relation	rel = info->index;
  	BlockNumber num_pages;
  
  	/* If hashbulkdelete wasn't called, return NULL signifying no change */
  	/* Note: this covers the analyze_only case too */
  	if (stats == NULL)
! 		return NULL;
  
  	/* update statistics */
  	num_pages = RelationGetNumberOfBlocks(rel);
  	stats->num_pages = num_pages;
  
! 	return stats;
  }
  
  
